/*
 		Example Silverlight Player - Gray
		
		Shows some Scale 9 action.
		
		jesse.warden@gmail.com
		jessewarden.com
		
		Design by Charles Schulze
		profilin54@gmail.com
	
		Released under GPL
		http://creativecommons.org/licenses/GPL/2.0/
*/

function onLoaded(sender, args)
{
	var plugin = sender.getHost();
	plugin.content.onFullScreenChange = onFullScreenChanged;
	plugin.content.onResize = onResized;
}

function onFullScreenChanged(sender, eventArgs)
{
	var plugin = sender.getHost();
	setSize(sender, plugin.content.actualWidth, plugin.content.actualHeight);
}

function onResized(sender, eventArgs)
{
	var plugin = sender.getHost();
	setSize(sender, plugin.content.actualWidth, plugin.content.actualHeight);
}

function playMedia(sender, args)
{
	sender.findName("media").play();
}

function stopMedia(sender, args)
{
	sender.findName("media").pause();
	
}

function fullscreenThisMugUpInHere(sender, args)
{
	var plugin = sender.getHost();
	plugin.content.fullScreen = !plugin.content.fullScreen;
}

function setSize(sender, width, height)
{
	var str = "";
	
	var plugin = sender.getHost();
	player = sender.findName("grayplayer");
	player.width = width;
	player.height = height;
	var bg_tl = sender.findName("bg_tl");
	var bg_br = sender.findName("bg_br");
	var bg_tr = sender.findName("bg_tr");
	var scale9 = new Scale9(bg_tl,
							sender.findName("bg_top"),
							bg_tr,
							sender.findName("bg_cl"),
							sender.findName("bg_center"),
							sender.findName("bg_cr"),
							sender.findName("bg_bl"),
							sender.findName("bg_bottom"),
							bg_br);
	var fullscreen_button = sender.findName("fullscreen_button");
	var margin = 12;
	var bgWidth = Math.max(width - margin, 300);
	var bgHeight = Math.max(height - margin - fullscreen_button.height, 220);
	scale9.redraw(sender, bgWidth, bgHeight, margin, margin);
	this.move(fullscreen_button, (this.getX(bg_br) + bg_br.width) - fullscreen_button.width - 8, height - fullscreen_button.height - margin);
	
	var playPause_button = sender.findName("playPause_button");
	this.move(playPause_button, this.getX(fullscreen_button) - playPause_button.width - 8, this.getY(fullscreen_button));
	
	var media = sender.findName("media");
	var theMediaX = Math.max(bg_tl.width / 2, this.getX(bg_tl));
	this.move(media, theMediaX, this.getY(bg_tl) + (bg_tl.height / 2));
	media.width = width - this.getX(media) - (bg_tr.width / 2)- margin;
	media.height = height - this.getY(media) - bg_br.height - margin;
}

function togglePlay(sender, args)
{
	var media = sender.findName("media");
	var playPause_button = sender.findName("playPause_button");
	switch(media.currentState)
	{
		case "Buffering":
		case "Closed":
		case "Error":
		case "Opening":
			break;
		
		case "Stopped":
		case "Paused":
			playPause_button.text = "Pause Video";
			media.play();
			break;
			
		case "Playing":
			playPause_button.text = "Play Video";
			media.pause();
			break;
	}
}

function getX(obj)
{
	return obj["Canvas.Left"];
}

function getY(obj)
{
	return obj["Canvas.Top"];
}

function move(obj, x, y)
{
	obj["Canvas.Left"] = x;
	obj["Canvas.Top"] = y;
}

Scale9 = function(tl, tc, tr, cl, c, cr, bl, bc, br)
	{
		this.tl = tl;
		this.tc = tc;
		this.tr = tr;
		this.cl = cl;
		this.c  = c;
		this.cr = cr;
		this.bl = bl;
		this.bc = bc;
		this.br = br;
	};

	Scale9.prototype.redraw = function(sender, width, height, offsetX, offsetY)
	{
		if(offsetX == null) offsetX = 0;
		if(offsetY == null) offsetY = 0;
		this.move(this.tl, offsetX, offsetY);

		this.move(this.tc, this.getX(this.tl) + this.tl.width, this.getY(this.tl));

		this.move(this.tr, width - this.tr.width, this.getY(this.tc));

		this.tc.width = width - this.getX(this.tc) - this.tr.width;

		this.move(this.cl, this.getX(this.tl), this.getY(this.tl) + this.tl.height);

		this.move(this.c, this.getX(this.cl) + this.cl.width, this.getY(this.cl));

		this.move(this.cr, width - this.cr.width, this.getY(this.cl));
		
		this.c.width = width - this.getX(this.c) - this.cr.width;

		this.move(this.bl, this.getX(this.cl), height - this.bl.height - 1);

		this.cl.height = height - this.getY(this.cl) - this.bl.height - 1;
		this.c.height = this.cl.height;
		this.cr.height = this.cl.height;

		this.move(this.br, width - this.br.width, height - this.br.height - 1);

		this.move(this.bc, this.getX(this.bl) + this.bl.width, this.getY(this.bl));

		this.bc.width = width - this.getX(this.bc) - this.br.width;
	};

	Scale9.prototype.move = function(obj, x, y)
	{
		obj["Canvas.Left"] = x;
		obj["Canvas.Top"] = y;
	};

	Scale9.prototype.getX = function(obj)
	{
		return obj["Canvas.Left"];
	};

	Scale9.prototype.getY = function(obj)
	{
		return obj["Canvas.Top"];
	};

